use glc::vector::Vector2f;
use serde::{Deserialize, Serialize};
use specs::{Component, VecStorage};

#[derive(Clone, Debug, Default, Serialize, Deserialize)]
pub struct Velocity {
    dir: Vector2f,
    speed: f32,
}

impl Velocity {
    pub fn new(dir: Vector2f, speed: f32) -> Self {
        Self { dir, speed }
    }

    pub fn dir(&self) -> &Vector2f {
        &self.dir
    }

    pub fn dir_mut(&mut self) -> &mut Vector2f {
        &mut self.dir
    }

    pub fn speed(&self) -> f32 {
        self.speed
    }
}

impl Component for Velocity {
    type Storage = VecStorage<Self>;
}
